
import sys
import operator
import xlrd

def getPlasmaWarhead(pltyp,env,dur,damage):

   if (pltyp == 'R'):
      if (dur <= 10):
         wh = 50
      elif (dur <= 15):
         wh = 35
      elif (dur <= 20):
         wh = 25
      elif (dur <= 25):
         wh = 20
      elif (dur <= 28):
         wh = 10
      elif (dur <= 29):
         wh = 5
      elif (dur <= 30):
         wh = 1
      else:
         wh = 0


   if (pltyp == 'S'):
      if (dur <= 10):
         wh = 30
      elif (dur <= 15):
         wh = 22
      elif (dur <= 20):
         wh = 15
      elif (dur <= 23):
         wh = 10
      elif (dur <= 24):
         wh = 5
      elif (dur <= 25):
         wh = 1
      else:
         wh = 0
      
   if (pltyp == 'G'):
      if (dur <= 10):
         wh = 20
      elif (dur <= 15):
         wh = 15
      elif (dur <= 18):
         wh = 10
      elif (dur <= 19):
         wh = 5
      elif (dur <= 20):
         wh = 1
      else:
         wh = 0      

   if (pltyp == 'F'):
      if (dur <= 5):
         wh = 20
      elif (dur <= 10):
         wh = 15
      elif (dur <= 12):
         wh = 10
      elif (dur <= 14):
         wh = 5
      elif (dur <= 15):
         wh = 1
      else:
         wh = 0    

   if (pltyp == 'D'):
      if (dur <= 5):
         wh = 10
      elif (dur <= 10):
         wh = 8
      elif (dur <= 12):
         wh = 5
      elif (dur <= 14):
         wh = 2
      elif (dur <= 15):
         wh = 1
      else:
         wh = 0 
      
   if (pltyp =='E'):
       wh=0

   if (env == 'E'):
      wh = wh * 2
   
   wh = wh - int(damage/2)

   return wh

# End of GetWarhead


def getUnitCount(Team,Order):
   
   global book
   
   sh = book.sheet_by_name(Team)
   
   count = 0
   for rx in range(sh.nrows):
      if (sh.cell_value(rx,1) == Order):
         count = count + 1
   return count      
   

def TeamSummary(Team,Turn):
   global book, ReportFile, Imp
   
   Orders = ['A','B','C','D','E','F','G','H']
   Types = ['Ships','PF/Ints','Fighters','Shuttles','Plasma','Drones','T-Bombs','Web']
   
   line = "---------------------------------------------------------------------------------\n"
   sh = book.sheet_by_name(Team)
   
   for i in range(0,8):
      nunits = getUnitCount(Team,Orders[i])
      if (nunits > 0):
         ReportFile.write(line)
         ReportFile.write(Team + ' ' + Types[i] + '\n')
         ReportFile.write(line)
         ReportFile.write('Unit       Class   Hex   Spd   EW')
         if (i == 2 or i == 3 or i == 5):
            ReportFile.write('  Lnch Dam')
         elif (i == 4):
            ReportFile.write('  Lnch Dam  WH')
         elif (i == 6):
            ReportFile.write('   Laid')
         elif (i == 7):
            ReportFile.write('   Laid  Str')
         ReportFile.write('  Notes\n')
         ReportFile.write(line)
         
         for rx in range(sh.nrows):
            if (sh.cell_value(rx,1) == Orders[i]):
               if (sh.cell_value(rx,12+Imp) not in ['','---']):
                  posimp = Imp
                  while (sh.cell_value(rx,12+posimp) == 'NM'):
                     posimp = posimp - 1
                  ReportFile.write(sh.cell_value(rx,0).ljust(10) + ' ' + sh.cell_value(rx,2).ljust(6) + ' ' + 
                                   sh.cell_value(rx,12+posimp).ljust(6)[0:5] + ' ' + str(int(sh.cell_value(rx,3))).rjust(4) + 
                                   str(int(sh.cell_value(rx,4))).rjust(3) + '/' + str(int(sh.cell_value(rx,5))).ljust(2) + ' ')
                  if (i==0 or i==1):
                     ReportFile.write(sh.cell_value(rx,11))
                  elif (i == 2 or i == 3 or i == 5):
                     ReportFile.write(sh.cell_value(rx,10).rjust(4) + str(int(sh.cell_value(rx,45))).rjust(4) + '  ' + sh.cell_value(rx,11))
                  elif (i == 4):
                     ReportFile.write(sh.cell_value(rx,10).rjust(4) + str(int(sh.cell_value(rx,45))).rjust(4))
                     pltype = sh.cell_value(rx,12)[0]
                     env = sh.cell_value(rx,12)[1]
                     crew = sh.cell_value(rx,55)
                     lti = str(sh.cell_value(rx,10)).split('.')
                     lTurn = int(lti[0])
                     lImp = int(lti[1])
                     if (lTurn == Turn):
                        dur = Imp -lImp
                     else:
                        dur = (32-lImp) + Imp
                     if (crew == 'CREW'):
                        dur = dur - 3
                     dam = int(sh.cell_value(rx,45))   
                     wh = getPlasmaWarhead(pltype,env,dur,dam)
                     ReportFile.write(str(wh).rjust(4) + '  ' + sh.cell_value(rx,11))  
                  elif (i == 6):
                     ReportFile.write( sh.cell_value(rx,10).rjust(5) + '  ' + sh.cell_value(rx,11)) 
                  elif (i == 7):
                     ReportFile.write( sh.cell_value(rx,10).rjust(5) + '  ' + str(int(sh.cell_value(rx,45))).rjust(3) + '  ' + sh.cell_value(rx,11)) 
                     
                  ReportFile.write('\n')                  
                                   
         
         ReportFile.write(line)
         ReportFile.write('\n\n')
               
            
def ProduceActions(Name,Letter,Turn):
   
   global book, Imp
   
   ActFile = open('Fog6'+str(Turn)+str(Imp).zfill(2)+Name+'Actions.txt',"w")
   ActFile.write("Actions Information for " + Name + ' as of ' + str(Turn) + '.' + str(Imp).zfill(2) + '\n')
   line = "---------------------------------------------------------------------------------\n"
   ActFile.write(line)
   ActFile.write("Imp Segment Action\n");
   ActFile.write(line)   
   
   sh = book.sheet_by_name('Actions')
   
   for rx in range(sh.nrows):
      if (sh.cell_value(rx,2) == 'A' or sh.cell_value(rx,2) == Letter):
         if (int(sh.cell_value(rx,0)) <= Imp):
            new = False
            if (rx == 1):
               new = True
            elif (sh.cell_value(rx,0) != sh.cell_value(rx-1,0)):
               new = True
            elif (sh.cell_value(rx,1) != sh.cell_value(rx-1,1)):
               new = True
               
            if (new):
               ActFile.write('\n' + str(int(sh.cell_value(rx,0))).rjust(3) + ':' + sh.cell_value(rx,1).ljust(8) + ' ' + sh.cell_value(rx,3)[0:60] + '\n')
               if (len(sh.cell_value(rx,3)) > 60):
                  ActFile.write('             ' + sh.cell_value(rx,3)[60:120] + '\n')
               if (len(sh.cell_value(rx,3)) > 120):
                  ActFile.write('             ' + sh.cell_value(rx,3)[120:180] + '\n')
            else:
               ActFile.write('             ' + sh.cell_value(rx,3)[0:60] + '\n')
               if (len(sh.cell_value(rx,3)) > 60):
                  ActFile.write('             ' + sh.cell_value(rx,3)[60:120] + '\n')
               if (len(sh.cell_value(rx,3)) > 120):
                  ActFile.write('             ' + sh.cell_value(rx,3)[120:180] + '\n')
           
               
   ActFile.close()            
        

def ProduceMoves(Friend,Enemy,Turn,MoveCt):

   global book, Imp
   
   MoveFile = open('Fog6'+str(Turn)+str(Imp).zfill(2)+Friend+'Movement.txt',"w")
   
   MoveFile.write('Movement for ' + str(Turn) + '.' + str(Imp).zfill(2) + ' ' + Friend + '\n')
   
   line = "-----------------------------------------------------" + '-'.ljust(7*MoveCt,'-')+"\n"
   
   sh = book.sheet_by_name(Friend)   
   
   eh = book.sheet_by_name(Enemy) 
   
   Orders = ['A','B','C','D','E','F','G','H']
   Types = ['Ships','PF/Ints','Fighters','Shuttles','Plasma','Drones','T-Bombs','Web']
   
   start = Imp - MoveCt+1;
   if (start <= 0):
      start = 1
   
   for i in range(0,8):
      nunits = getUnitCount(Friend,Orders[i])
      if (nunits > 0):
         MoveFile.write(line)
         MoveFile.write(Friend + ' ' + Types[i] + '\n')
         MoveFile.write(line)
         MoveFile.write('Unit       Spd ')
         for j in range(start,Imp+1):
            MoveFile.write(str(j).rjust(4)+'   ')
         MoveFile.write(' Launch Target     Notes\n')
         MoveFile.write(line)
         for fx in range(sh.nrows):
             if (sh.cell_value(fx,1) == Orders[i] and sh.cell_value(fx,12+start) != '---' and sh.cell_value(fx,12+Imp) != ''):
               MoveFile.write(sh.cell_value(fx,0).ljust(10) + str(int(sh.cell_value(fx,3))).rjust(3) + '  ' )
               for k in range(start,Imp+1):
                  MoveFile.write(sh.cell_value(fx,12+k).ljust(7))
               MoveFile.write(sh.cell_value(fx,10).rjust(7)+' ')
               MoveFile.write(sh.cell_value(fx,8).ljust(10)+' ')
               MoveFile.write(sh.cell_value(fx,12)+'\n')
         MoveFile.write(line)
         MoveFile.write('\n\n')
         
   MoveFile.write('\n\n')
         
   for i in range(0,8):
      nunits = getUnitCount(Enemy,Orders[i])
      if (nunits > 0):
         MoveFile.write(line)
         MoveFile.write(Enemy + ' ' + Types[i] + '\n')
         MoveFile.write(line)
         MoveFile.write('Unit       Spd ')
         for j in range(start,Imp+1):
            MoveFile.write(str(j).rjust(4)+'   ')
         MoveFile.write(' Launch\n')
         MoveFile.write(line)
         for fx in range(eh.nrows):
            if (eh.cell_value(fx,1) == Orders[i] and eh.cell_value(fx,12+start) != '---' and eh.cell_value(fx,12+Imp) != ''):
               MoveFile.write(eh.cell_value(fx,0).ljust(10) + str(int(eh.cell_value(fx,3))).rjust(3) + '  ' )
               for k in range(start,Imp+1):
                  MoveFile.write(eh.cell_value(fx,12+k).ljust(7))
               MoveFile.write(eh.cell_value(fx,10).rjust(5)+'\n')
         MoveFile.write(line)               
         MoveFile.write('\n\n')
         

def ProduceSummary(T1Name,T2Name,Turn):

   global book, ReportFile, Imp
   
   ReportFile = open('Fog6'+str(Turn)+str(Imp).zfill(2)+'Summary.txt',"w")
   
   ReportFile.write("Summary Information for " + str(Turn) + '.' + str(Imp).zfill(2) + '\n')
   
   TeamSummary(T1Name,Turn)
   TeamSummary(T2Name,Turn)
   
   ReportFile.close()


def ProduceSitrep():

    global book, Imp
    
    ti = sys.argv[1].split('.')
    Turn = int(ti[0])
    Imp = int(ti[1])
    
    ExcelFile = "F:\Jim\Stick\Fog4Moderation\Moderation\Fog6Turn" + str(Turn) + '.xls'
    
    T1Name = "Black"
    T2Name = "Yellow"
    T1Letter = T1Name[0]
    T2Letter = T2Name[0]
   
    book = xlrd.open_workbook(ExcelFile)
   
    ProduceSummary(T1Name,T2Name,Turn)
    
    ProduceActions(T1Name,T1Letter,Turn)
    ProduceActions(T2Name,T2Letter,Turn)
    
    ProduceMoves(T1Name,T2Name,Turn,4)
    ProduceMoves(T2Name,T1Name,Turn,4)
 
      
ProduceSitrep()   

