import sys
import operator
import xlrd
import xlwt

class XLBOOK:

    def __init__(self, excelFile):
        self.book = xlrd.open_workbook(excelFile, formatting_info=True)
         = excelFile
        self.Set_Sheet_By_Number(0)

    # End of __Init__


    excelFile = ""
    book = ""
    sheet = "error"
    sheetNum = 1
    sheetName="error"
    row = 0
    col = 0
    cell = ""

    def Write_Excel(excelFile = self.excelFile)
        xlwd.save(excelFile)

    def Set_Sheet_By_Name(self,sheetName):
        self.sheet = self.book.sheet_by_name(sheetName)
        
        self.sheetName = sheetName
        sheetNames = self.book.sheet_names()
        self.sheetNum = sheetNames.index(sheetName)
        self.SetRow(0)
        self.SetCol(0)
        return sheetName

    # End of SetSheetByName
        

    def Set_Sheet_By_Number(self,sheetNum):
        self.sheet = self.book.sheet_by_index(sheetNum)
        sheetNames = self.book.sheets()
        self.sheetName = sheetNames[sheetNum - 1]
        self.sheetNum = sheetNum
        self.SetRow(0)
        self.SetCol(0)
        return sheetNum

    # End of SetSheetByNumber


    def SetRow(self,row):
        self.row = row
        self.cell = self.sheet.cell(self.row,self.col)
        return row

    # End of SetRow
    

    def SetCol(self,col):
        self.col = col
        self.cell = self.sheet.cell(self.row,self.col)
        return col
    

    def Find_Col_By_Value(self, value, row = -1):

        if (row != -1):
            row = self.SetRow(row)
        else:
            row = self.row

        colList = self.sheet.row_values(row)
        col = -1
        
        if (value in colList):
            col = colList.index(value)
            self.row = 0
            self.SetCol(col)

        return col

    # end Find_Col_By_Value


    def Find_Row_By_Value(self, value, col = -1):

        if (col != -1):
            col = self.SetCol(col)
        else:
            col = self.col

        rowList = self.sheet.col_values(self.col)
        row = -1
        
        if (rowName in rowList):
            row = rowList.index(rowName)
            self.SetRow(row)

        return row

    # end Find_Row_By_Value


    def Get_Cell_Value(self, row=-1, col=-1):

        if (row != -1):
            row = self.SetRow(row)
        else:
            row = self.row

        if (col != -1):
            col = self.SetCol(col)
        else:
            col = self.col

        cellValue = self.cell.value
        cellType = self.cell.ctype

        return cellValue, cellType

    # end of Get_Cell_Value

    def Save_Cell_Value(self, value, row=-1, col=-1):

        if (row != -1):
            row = self.SetRow(row)
        else:
            row = self.row

        if (col != -1):
            col = self.SetCol(col)
        else:
            col = self.col

        self.cell.value = value
        cellType = self.cell.ctype

        return cellValue

    # end of Save_Cell_Value


    def Get_Vert_Strip(self, col=-1, rowStart=-1, rowEnd = -1):

        if (rowStart != -1):
            rowStart = self.row
        else:
            rowStart = 0

        if (col != -1):
            col = self.SetCol(col)
        else:
            col = self.col

        if (rowEnd == -1):
             colList = self.sheet.col_values(col, rowStart)
        else:
             colList = self.sheet.col_values(col, rowStart, rowEnd)
        

        return colList
           

    # end of Get_Vert_Strip


    def Get_Horiz_Strip(self, row=-1, colStart=-1, colEnd = -1):

        if (colStart != -1):
            colStart = self.col
        else:
            colStart = 0

        if (row != -1):
            row = self.SetRow(row)
        else:
            row = self.row


        if (colEnd == -1):
             rowList = self.sheet.row_values(row, colStart)
        else:
             rowList = self.sheet.row_values(row, colStart, colEnd)
        

        return rowList
           

    # end of Get_Vert_Strip


    def XlColor_To_WebColor(self,xlColor):

        ShowComments = False

        if (ShowComments):
            sys.stdout.write("xlColor = >")
            sys.stdout.write(xlColor)
            sys.stdout.write("<\n")

        rgbProd = "#"
        for i in xlColor:
            rgbVal = hex(i).split("0x")[1]
            if (len(rgbVal) < 2):
                rgbVal = "0" + rgbVal
                
            rgbProd = rgbProd +rgbVal
            
            if (ShowComments):
                sys.stdout.write("i = >")
                sys.stdout.write(i)
                sys.stdout.write("<\n")
                sys.stdout.write("rgbProd = >")
                sys.stdout.write(rgbProd)
                sys.stdout.write("<\n")
            
        return rgbProd

    # End of XlColor_To_WebColor


    def Cell_Font_Color(self,row=-1,col=-1):

        if (row != -1):
            row = self.SetRow(row)
        else:
            row = self.row

        if (col != -1):
            col = self.SetCol(col)
        else:
            col = self.col

        book = self.book
        sheet = self.sheet
        cell = self.cell

    # Get to the XF info for the cell
        xfx = sheet.cell_xf_index(row,col)
        xf= book.xf_list[xfx]

    # Get font color info
        fontx = book.font_list[xf.font_index]
        fontRGB = book.colour_map[fontx.colour_index]

    # Convert Excel RBG to web RGB
        return self.XlColor_To_WebColor(fontRGB)

    # end Get_Font_Colors


    def Cell_BG_Color(self,row=-1,col=-1):

        if (row != -1):
            row = self.SetRow(row)
        else:
            row = self.row

        if (col != -1):
            col = self.SetCol(col)
        else:
            col = self.col


        book = self.book
        sheet = self.sheet
        cell = self.cell

    # Get to the XF info for the cell
        cell = sheet.cell(row,col)
        xfx = sheet.cell_xf_index(row,col)
        xf= book.xf_list[xfx]

    # Get background color info
        bgx = xf.background.pattern_colour_index
        bgRGB = book.colour_map[bgx]

        return self.XlColor_To_WebColor(bgRGB)

    # end Get_BG_Color

# End of XLBook class
